'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SearchInput = exports.InputBig = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _FormElement2 = require('../FormElement');

var _FormElement3 = _interopRequireDefault(_FormElement2);

var _styles = require('./styles');

var _SearchInput = require('./SearchInput');

var _SearchInput2 = _interopRequireDefault(_SearchInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function createComponent(Component) {
    return function (_FormElement) {
        _inherits(_class2, _FormElement);

        function _class2(props) {
            _classCallCheck(this, _class2);

            var _this = _possibleConstructorReturn(this, (_class2.__proto__ || Object.getPrototypeOf(_class2)).call(this, props));

            _this.keyUpHandler = function (e) {
                var value = e.target.value;
                _this.setState({ inputvalue: value });
                if (_this.props.onChange) {
                    _this.props.onChange(value, _this.props.name);
                }
            };

            _this.state = {
                inputvalue: props.value || ''
            };
            return _this;
        }

        _createClass(_class2, [{
            key: 'componentWillReceiveProps',
            value: function componentWillReceiveProps(nextProps) {
                if (this.props.value !== nextProps.value) {
                    this.setState({
                        inputvalue: nextProps.value || ''
                    });
                }
            }
        }, {
            key: 'render',
            value: function render() {
                var options = (0, _omit3.default)(this.props, ['value', 'onChange']);
                return _react2.default.createElement(Component, _extends({
                    value: this.state.inputvalue,
                    onChange: this.keyUpHandler
                }, options));
            }
        }]);

        return _class2;
    }(_FormElement3.default);
}

var Input = createComponent(_styles.StyledInput);
var InputBig = createComponent(_styles.StyledInputBig);

Input.propTypes = {
    state: _propTypes2.default.oneOf(['default', 'errored']),
    placeholder: _propTypes2.default.string
};

Input.defaultProps = {
    state: 'default',
    placeholder: ''
};

InputBig.propTypes = {
    state: _propTypes2.default.oneOf(['default', 'errored']),
    placeholder: _propTypes2.default.string
};

InputBig.defaultProps = {
    state: 'default',
    placeholder: ''
};

exports.default = Input;
exports.InputBig = InputBig;
exports.SearchInput = _SearchInput2.default;